#include <iostream>
#include <algorithm>
#include <cmath>
#define MAXN (1<<6)
#define INF (1<<20)
#define EPS (1e-6)
using namespace std;;

struct sud
{
    double maxx, cur;
    sud () {}
    sud (double _maxx) : maxx(_maxx) { cur = 0.; }
};

int n;
double s;
sud a[MAXN];
//1 .. n

void print ()
{
    cout << a[1].cur;
    for (int i=2; i <= n; ++i)
        cout << " " << a[i].cur;
    cout << endl;
}

int main ()
{
    cin >> n;

    for (int i=1; i < n; ++i)
    {
        double t;
        cin >> t;
        a[i] = sud (t);
    }
    a[n] = sud (INF);
    cin >> s;

    while ( s > EPS)
    {
        //print ();
        //cout << s << endl;
        int key = -1;
        for (int i=1; i <= n; ++i)
            if (a[i].maxx - a[i].cur > EPS)
                { key = i; break; }
        //cout << "found key = " << key << endl;
        if (key == 1)
        {
            if (a[1].maxx - s > EPS)
                { a[1].cur = s; break; }
            s -= (a[1].maxx-a[1].cur);
            //cout << (a[1].maxx-a[1].cur) << ' ' << a[1].maxx << ' ' << a[1].cur << endl;
            a[1].cur = a[1].maxx;
            continue;
        }
        double to = a[key].maxx;

        for (int i=key-1; i >= 1; --i)
            if (a[i].cur - a[key].cur > EPS)
                to = min ( to, a[i].cur );
        //cout << to << endl;
        int br=1;

        for (int i=key-1; i >= 1; --i, br++)
            if ( a[i].cur - to > EPS || abs(a[i].cur - to) < EPS)
                break;

        double h = 0.;
        for (int i=key; i >= key-br+1; --i)
            h += to - a[i].cur;
        //cout << "h " << h << endl;
        //cout << br << endl;
        for (int i=key; i >= key-br+1; --i)
            a[i].cur += min (a[i].cur+(s/double(br)), to) - a[i].cur;

        s -= min (s, h);
    }

    print ();
    return 0;
}
