#include <stdio.h>
#include <assert.h>

const int MAXN = 1 << 10;
const int MBS = 64;

int N;
double con[MAXN];
double tot;

double res[MAXN];

int main() {
  scanf("%d", &N);
  for (int i = 1; i < N; ++i)
    scanf("%lf", con + i);
  scanf("%lf", &tot);

  double cmax = tot;
  for (int ci = 0; ci < N;) {
    double l = 0, r = cmax, m;
    int last_reached = -1;
    if (tot < 1e-9)
      break;
    for (int bs = 0; bs < MBS; ++bs) {
      m = (l + r) / 2.;
      int i;
      double poured = 0;
      for (i = ci;
             i < N
          && (i == ci || con[i] <= m)
          && (poured = (i + 1 - ci) * m) < tot;
          ++i) ;
      if (poured < tot) {
        l = m;
        last_reached = i;
      } else {
        r = m;
      }
    }
    assert(last_reached != -1);
    tot -= (last_reached - ci) * l;
    for (; ci < last_reached; ++ci)
      res[ci] = l;
    cmax = l;
  }

  printf("%lf", res[0]);
  for (int i = 1; i < N; ++i)
    printf(" %lf", res[i]);
  puts("");

  return 0;
}
