#include <cstdio>
#include <vector>
#include <iostream>

#define min(x,y) ( ( (x) < (y) ) ? (x) : (y) )

using namespace std;

int N;
double T;
vector <double> v, h;
vector<int> buck[64];
double out[64];

void print () {
	for(int i=0; i<v.size(); ++i) printf( "%.3lf ", v[i] ); printf ( "\n" );
	for(int i=0; i<h.size(); ++i) printf( "%.3lf ", h[i] ); printf ( "\n" );
	}

void dfs ( int i ) {
//	cout<<"->"<<i<<endl;
	//printf("At:%d  %.3lf\n", i, T);
	//print ();
	if(T==0. ) return;
	//if( i>v.size()-1 ) return;
	if( v[i] < h[i] && !i ) {
		v[i] = min ( T, h[i] );
		T -= v[i];
		 dfs ( i+1 );
		}
	else
	if( h[i] > h[i-1] ) {
		//cout<<"less\n";
		v[i] = min ( v[i-1], T );
		T -= v[i];

		if( T==0. ) return;

		buck[i-1].push_back(i);
		buck[i].erase(buck[i].begin());
		h.erase(h.begin()+i-1,h.begin()+i);
		v.erase(v.begin()+i-1,v.begin()+i);


		dfs(i-1);
		}
	else{
		v[i] = min ( T, h[i] );
		T -= v[i];

		dfs(i+1);

		}

	}

int main (void) {
		scanf ( "%d", &N );
		double x;
		v.resize(N);
		h.resize(N);
		for(int i=0; i<N-1; ++i) { scanf ( "%lf", &x ); h[i]=x; }

		scanf( "%lf", &T );

		for(int i=0; i<=N; ++i) buck[i].push_back(i);
		for(int i=0; i<N; ++i) v[i]=0.;
		h[N-1]=1e6;
		//print ();

		dfs(0);
		//print();
		int cnt = 0;
		for(int i=0; i<N; ++i) {
			//for(int j=0; j<buck[i].size(); ++j) //printf ("%d ", buck[i][j]);
			if( buck[i].size() > 0 ) {
				for(int j=0; j<buck[i].size(); ++j) {
					out[ buck[i][j] ] = v[cnt];
					}
				++cnt;
				}
			//printf("\n");
			}

		for(int i=0; i<N; ++i) {
			if( i ) printf ( " %.6lf", out[i] );
			else printf ( "%.6lf", out[i] );
			}

		printf ( "\n" );
}